unit AutoHeightFlowLayout;

interface
uses
  Vcl.ExtCtrls, Vcl.Controls, System.Classes, System.SysUtils, System.Types;

type
  // Add autoHeight property
  TAutoHeightFlowLayout = class(TFlowPanel)
  private
    FAutoHeight : boolean;
    procedure SetAutoHeight(const Value: boolean);
    procedure AdjustHeight();
  protected
    procedure AlignControls(AControl: TControl; var Rect: TRect); override;
  published
    property AutoHeight : boolean read FAutoHeight write SetAutoHeight;
  public
    constructor Create(AOwner: TComponent); override;
  end;

implementation

{ TMyFlowLayout }

procedure TAutoHeightFlowLayout.AdjustHeight;
begin
  var H := 0;

  for var i := 0 to self.ControlCount-1 do
  begin
    var c := self.controls[i];

    if H < (c.top + c.Height) then
      H := c.top + c.Height + c.Margins.Bottom + self.Padding.Bottom;
  end;

  if Height < H then
    Height := H;
end;

procedure TAutoHeightFlowLayout.AlignControls(AControl: TControl;
  var Rect: TRect);
begin
  inherited;

  if FAutoHeight then
    AdjustHeight();
end;

constructor TAutoHeightFlowLayout.Create(AOwner: TComponent);
begin
  inherited;
  FAutoHeight := True;
end;

procedure TAutoHeightFlowLayout.SetAutoHeight(const Value: boolean);
begin
  FAutoHeight := Value;
end;

end.
