// 
// Created by the DataSnap proxy generator.
// 21/02/2023 3:09:02 PM
// 

unit ServerMethodsClient;

interface

uses System.JSON, Datasnap.DSProxyRest, Datasnap.DSClientRest, Data.DBXCommon, Data.DBXClient, Data.DBXDataSnap, Data.DBXJSON, Datasnap.DSProxy, System.Classes, System.SysUtils, Data.DB, Data.SqlExpr, Data.DBXDBReaders, Data.DBXCDSReaders, Data.FireDACJSONReflect, Data.DBXJSONReflect;

type

  IDSRestCachedTFDJSONDataSets = interface;

  TSvrSQLMethodsClient = class(TDSAdminRestClient)
  private
    FLoginCommand: TDSRestCommand;
    FConnectionStringCommand: TDSRestCommand;
    FExecSQLCommand: TDSRestCommand;
    FExecResSQLCommand: TDSRestCommand;
    FOpenSQLCommand: TDSRestCommand;
    FOpenSQLCommand_Cache: TDSRestCommand;
    FOpenResSQLCommand: TDSRestCommand;
    FOpenResSQLCommand_Cache: TDSRestCommand;
    FApplyUpdatesByDSCommand: TDSRestCommand;
    FCheckTableAndFieldCommand: TDSRestCommand;
    FBeginTransactionsCommand: TDSRestCommand;
    FCommitTransactionsCommand: TDSRestCommand;
    FRollbackTransactionsCommand: TDSRestCommand;
    FEchoStringCommand: TDSRestCommand;
    FReverseStringCommand: TDSRestCommand;
    FCreateDataProviderCommand: TDSRestCommand;
    FReleaseDataProviderCommand: TDSRestCommand;
  public
    constructor Create(ARestConnection: TDSRestConnection); overload;
    constructor Create(ARestConnection: TDSRestConnection; AInstanceOwner: Boolean); overload;
    destructor Destroy; override;
    function Login(UserName: string; UserPassword: string; const ARequestFilter: string = ''): Boolean;
    function ConnectionString(const ARequestFilter: string = ''): string;
    procedure ExecSQL(SQL: string; Params: TJSONArray);
    procedure ExecResSQL(ResSQL: string; Params: TJSONArray);
    function OpenSQL(SQL: string; Params: TJSONArray; const ARequestFilter: string = ''): TFDJSONDataSets;
    function OpenSQL_Cache(SQL: string; Params: TJSONArray; const ARequestFilter: string = ''): IDSRestCachedTFDJSONDataSets;
    function OpenResSQL(ResSQL: string; Params: TJSONArray; const ARequestFilter: string = ''): TFDJSONDataSets;
    function OpenResSQL_Cache(ResSQL: string; Params: TJSONArray; const ARequestFilter: string = ''): IDSRestCachedTFDJSONDataSets;
    procedure ApplyUpdatesByDS(TableName: string; TableAlias: string; WhereAnd: string; KeyFields: string; List: TFDJSONDataSets);
    function CheckTableAndField(s: string; const ARequestFilter: string = ''): Boolean;
    procedure BeginTransactions;
    procedure CommitTransactions;
    procedure RollbackTransactions;
    function EchoString(Value: string; const ARequestFilter: string = ''): string;
    function ReverseString(Value: string; const ARequestFilter: string = ''): string;
    procedure CreateDataProvider;
    procedure ReleaseDataProvider;
  end;

  IDSRestCachedTFDJSONDataSets = interface(IDSRestCachedObject<TFDJSONDataSets>)
  end;

  TDSRestCachedTFDJSONDataSets = class(TDSRestCachedObject<TFDJSONDataSets>, IDSRestCachedTFDJSONDataSets, IDSRestCachedCommand)
  end;

const
  TSvrSQLMethods_Login: array [0..2] of TDSRestParameterMetaData =
  (
    (Name: 'UserName'; Direction: 1; DBXType: 26; TypeName: 'string'),
    (Name: 'UserPassword'; Direction: 1; DBXType: 26; TypeName: 'string'),
    (Name: ''; Direction: 4; DBXType: 4; TypeName: 'Boolean')
  );

  TSvrSQLMethods_ConnectionString: array [0..0] of TDSRestParameterMetaData =
  (
    (Name: ''; Direction: 4; DBXType: 26; TypeName: 'string')
  );

  TSvrSQLMethods_ExecSQL: array [0..1] of TDSRestParameterMetaData =
  (
    (Name: 'SQL'; Direction: 1; DBXType: 26; TypeName: 'string'),
    (Name: 'Params'; Direction: 1; DBXType: 37; TypeName: 'TJSONArray')
  );

  TSvrSQLMethods_ExecResSQL: array [0..1] of TDSRestParameterMetaData =
  (
    (Name: 'ResSQL'; Direction: 1; DBXType: 26; TypeName: 'string'),
    (Name: 'Params'; Direction: 1; DBXType: 37; TypeName: 'TJSONArray')
  );

  TSvrSQLMethods_OpenSQL: array [0..2] of TDSRestParameterMetaData =
  (
    (Name: 'SQL'; Direction: 1; DBXType: 26; TypeName: 'string'),
    (Name: 'Params'; Direction: 1; DBXType: 37; TypeName: 'TJSONArray'),
    (Name: ''; Direction: 4; DBXType: 37; TypeName: 'TFDJSONDataSets')
  );

  TSvrSQLMethods_OpenSQL_Cache: array [0..2] of TDSRestParameterMetaData =
  (
    (Name: 'SQL'; Direction: 1; DBXType: 26; TypeName: 'string'),
    (Name: 'Params'; Direction: 1; DBXType: 37; TypeName: 'TJSONArray'),
    (Name: ''; Direction: 4; DBXType: 26; TypeName: 'String')
  );

  TSvrSQLMethods_OpenResSQL: array [0..2] of TDSRestParameterMetaData =
  (
    (Name: 'ResSQL'; Direction: 1; DBXType: 26; TypeName: 'string'),
    (Name: 'Params'; Direction: 1; DBXType: 37; TypeName: 'TJSONArray'),
    (Name: ''; Direction: 4; DBXType: 37; TypeName: 'TFDJSONDataSets')
  );

  TSvrSQLMethods_OpenResSQL_Cache: array [0..2] of TDSRestParameterMetaData =
  (
    (Name: 'ResSQL'; Direction: 1; DBXType: 26; TypeName: 'string'),
    (Name: 'Params'; Direction: 1; DBXType: 37; TypeName: 'TJSONArray'),
    (Name: ''; Direction: 4; DBXType: 26; TypeName: 'String')
  );

  TSvrSQLMethods_ApplyUpdatesByDS: array [0..4] of TDSRestParameterMetaData =
  (
    (Name: 'TableName'; Direction: 1; DBXType: 26; TypeName: 'string'),
    (Name: 'TableAlias'; Direction: 1; DBXType: 26; TypeName: 'string'),
    (Name: 'WhereAnd'; Direction: 1; DBXType: 26; TypeName: 'string'),
    (Name: 'KeyFields'; Direction: 1; DBXType: 26; TypeName: 'string'),
    (Name: 'List'; Direction: 1; DBXType: 37; TypeName: 'TFDJSONDataSets')
  );

  TSvrSQLMethods_CheckTableAndField: array [0..1] of TDSRestParameterMetaData =
  (
    (Name: 's'; Direction: 1; DBXType: 26; TypeName: 'string'),
    (Name: ''; Direction: 4; DBXType: 4; TypeName: 'Boolean')
  );

  TSvrSQLMethods_EchoString: array [0..1] of TDSRestParameterMetaData =
  (
    (Name: 'Value'; Direction: 1; DBXType: 26; TypeName: 'string'),
    (Name: ''; Direction: 4; DBXType: 26; TypeName: 'string')
  );

  TSvrSQLMethods_ReverseString: array [0..1] of TDSRestParameterMetaData =
  (
    (Name: 'Value'; Direction: 1; DBXType: 26; TypeName: 'string'),
    (Name: ''; Direction: 4; DBXType: 26; TypeName: 'string')
  );

implementation

function TSvrSQLMethodsClient.Login(UserName: string; UserPassword: string; const ARequestFilter: string): Boolean;
begin
  if FLoginCommand = nil then
  begin
    FLoginCommand := FConnection.CreateCommand;
    FLoginCommand.RequestType := 'GET';
    FLoginCommand.Text := 'TSvrSQLMethods.Login';
    FLoginCommand.Prepare(TSvrSQLMethods_Login);
  end;
  FLoginCommand.Parameters[0].Value.SetWideString(UserName);
  FLoginCommand.Parameters[1].Value.SetWideString(UserPassword);
  FLoginCommand.Execute(ARequestFilter);
  Result := FLoginCommand.Parameters[2].Value.GetBoolean;
end;

function TSvrSQLMethodsClient.ConnectionString(const ARequestFilter: string): string;
begin
  if FConnectionStringCommand = nil then
  begin
    FConnectionStringCommand := FConnection.CreateCommand;
    FConnectionStringCommand.RequestType := 'GET';
    FConnectionStringCommand.Text := 'TSvrSQLMethods.ConnectionString';
    FConnectionStringCommand.Prepare(TSvrSQLMethods_ConnectionString);
  end;
  FConnectionStringCommand.Execute(ARequestFilter);
  Result := FConnectionStringCommand.Parameters[0].Value.GetWideString;
end;

procedure TSvrSQLMethodsClient.ExecSQL(SQL: string; Params: TJSONArray);
begin
  if FExecSQLCommand = nil then
  begin
    FExecSQLCommand := FConnection.CreateCommand;
    FExecSQLCommand.RequestType := 'POST';
    FExecSQLCommand.Text := 'TSvrSQLMethods."ExecSQL"';
    FExecSQLCommand.Prepare(TSvrSQLMethods_ExecSQL);
  end;
  FExecSQLCommand.Parameters[0].Value.SetWideString(SQL);
  FExecSQLCommand.Parameters[1].Value.SetJSONValue(Params, FInstanceOwner);
  FExecSQLCommand.Execute;
end;

procedure TSvrSQLMethodsClient.ExecResSQL(ResSQL: string; Params: TJSONArray);
begin
  if FExecResSQLCommand = nil then
  begin
    FExecResSQLCommand := FConnection.CreateCommand;
    FExecResSQLCommand.RequestType := 'POST';
    FExecResSQLCommand.Text := 'TSvrSQLMethods."ExecResSQL"';
    FExecResSQLCommand.Prepare(TSvrSQLMethods_ExecResSQL);
  end;
  FExecResSQLCommand.Parameters[0].Value.SetWideString(ResSQL);
  FExecResSQLCommand.Parameters[1].Value.SetJSONValue(Params, FInstanceOwner);
  FExecResSQLCommand.Execute;
end;

function TSvrSQLMethodsClient.OpenSQL(SQL: string; Params: TJSONArray; const ARequestFilter: string): TFDJSONDataSets;
begin
  if FOpenSQLCommand = nil then
  begin
    FOpenSQLCommand := FConnection.CreateCommand;
    FOpenSQLCommand.RequestType := 'POST';
    FOpenSQLCommand.Text := 'TSvrSQLMethods."OpenSQL"';
    FOpenSQLCommand.Prepare(TSvrSQLMethods_OpenSQL);
  end;
  FOpenSQLCommand.Parameters[0].Value.SetWideString(SQL);
  FOpenSQLCommand.Parameters[1].Value.SetJSONValue(Params, FInstanceOwner);
  FOpenSQLCommand.Execute(ARequestFilter);
  if not FOpenSQLCommand.Parameters[2].Value.IsNull then
  begin
    FUnMarshal := TDSRestCommand(FOpenSQLCommand.Parameters[2].ConnectionHandler).GetJSONUnMarshaler;
    try
      Result := TFDJSONDataSets(FUnMarshal.UnMarshal(FOpenSQLCommand.Parameters[2].Value.GetJSONValue(True)));
      if FInstanceOwner then
        FOpenSQLCommand.FreeOnExecute(Result);
    finally
      FreeAndNil(FUnMarshal)
    end
  end
  else
    Result := nil;
end;

function TSvrSQLMethodsClient.OpenSQL_Cache(SQL: string; Params: TJSONArray; const ARequestFilter: string): IDSRestCachedTFDJSONDataSets;
begin
  if FOpenSQLCommand_Cache = nil then
  begin
    FOpenSQLCommand_Cache := FConnection.CreateCommand;
    FOpenSQLCommand_Cache.RequestType := 'POST';
    FOpenSQLCommand_Cache.Text := 'TSvrSQLMethods."OpenSQL"';
    FOpenSQLCommand_Cache.Prepare(TSvrSQLMethods_OpenSQL_Cache);
  end;
  FOpenSQLCommand_Cache.Parameters[0].Value.SetWideString(SQL);
  FOpenSQLCommand_Cache.Parameters[1].Value.SetJSONValue(Params, FInstanceOwner);
  FOpenSQLCommand_Cache.ExecuteCache(ARequestFilter);
  Result := TDSRestCachedTFDJSONDataSets.Create(FOpenSQLCommand_Cache.Parameters[2].Value.GetString);
end;

function TSvrSQLMethodsClient.OpenResSQL(ResSQL: string; Params: TJSONArray; const ARequestFilter: string): TFDJSONDataSets;
begin
  if FOpenResSQLCommand = nil then
  begin
    FOpenResSQLCommand := FConnection.CreateCommand;
    FOpenResSQLCommand.RequestType := 'POST';
    FOpenResSQLCommand.Text := 'TSvrSQLMethods."OpenResSQL"';
    FOpenResSQLCommand.Prepare(TSvrSQLMethods_OpenResSQL);
  end;
  FOpenResSQLCommand.Parameters[0].Value.SetWideString(ResSQL);
  FOpenResSQLCommand.Parameters[1].Value.SetJSONValue(Params, FInstanceOwner);
  FOpenResSQLCommand.Execute(ARequestFilter);
  if not FOpenResSQLCommand.Parameters[2].Value.IsNull then
  begin
    FUnMarshal := TDSRestCommand(FOpenResSQLCommand.Parameters[2].ConnectionHandler).GetJSONUnMarshaler;
    try
      Result := TFDJSONDataSets(FUnMarshal.UnMarshal(FOpenResSQLCommand.Parameters[2].Value.GetJSONValue(True)));
      if FInstanceOwner then
        FOpenResSQLCommand.FreeOnExecute(Result);
    finally
      FreeAndNil(FUnMarshal)
    end
  end
  else
    Result := nil;
end;

function TSvrSQLMethodsClient.OpenResSQL_Cache(ResSQL: string; Params: TJSONArray; const ARequestFilter: string): IDSRestCachedTFDJSONDataSets;
begin
  if FOpenResSQLCommand_Cache = nil then
  begin
    FOpenResSQLCommand_Cache := FConnection.CreateCommand;
    FOpenResSQLCommand_Cache.RequestType := 'POST';
    FOpenResSQLCommand_Cache.Text := 'TSvrSQLMethods."OpenResSQL"';
    FOpenResSQLCommand_Cache.Prepare(TSvrSQLMethods_OpenResSQL_Cache);
  end;
  FOpenResSQLCommand_Cache.Parameters[0].Value.SetWideString(ResSQL);
  FOpenResSQLCommand_Cache.Parameters[1].Value.SetJSONValue(Params, FInstanceOwner);
  FOpenResSQLCommand_Cache.ExecuteCache(ARequestFilter);
  Result := TDSRestCachedTFDJSONDataSets.Create(FOpenResSQLCommand_Cache.Parameters[2].Value.GetString);
end;

procedure TSvrSQLMethodsClient.ApplyUpdatesByDS(TableName: string; TableAlias: string; WhereAnd: string; KeyFields: string; List: TFDJSONDataSets);
begin
  if FApplyUpdatesByDSCommand = nil then
  begin
    FApplyUpdatesByDSCommand := FConnection.CreateCommand;
    FApplyUpdatesByDSCommand.RequestType := 'POST';
    FApplyUpdatesByDSCommand.Text := 'TSvrSQLMethods."ApplyUpdatesByDS"';
    FApplyUpdatesByDSCommand.Prepare(TSvrSQLMethods_ApplyUpdatesByDS);
  end;
  FApplyUpdatesByDSCommand.Parameters[0].Value.SetWideString(TableName);
  FApplyUpdatesByDSCommand.Parameters[1].Value.SetWideString(TableAlias);
  FApplyUpdatesByDSCommand.Parameters[2].Value.SetWideString(WhereAnd);
  FApplyUpdatesByDSCommand.Parameters[3].Value.SetWideString(KeyFields);
  if not Assigned(List) then
    FApplyUpdatesByDSCommand.Parameters[4].Value.SetNull
  else
  begin
    FMarshal := TDSRestCommand(FApplyUpdatesByDSCommand.Parameters[4].ConnectionHandler).GetJSONMarshaler;
    try
      FApplyUpdatesByDSCommand.Parameters[4].Value.SetJSONValue(FMarshal.Marshal(List), True);
      if FInstanceOwner then
        List.Free
    finally
      FreeAndNil(FMarshal)
    end
    end;
  FApplyUpdatesByDSCommand.Execute;
end;

function TSvrSQLMethodsClient.CheckTableAndField(s: string; const ARequestFilter: string): Boolean;
begin
  if FCheckTableAndFieldCommand = nil then
  begin
    FCheckTableAndFieldCommand := FConnection.CreateCommand;
    FCheckTableAndFieldCommand.RequestType := 'GET';
    FCheckTableAndFieldCommand.Text := 'TSvrSQLMethods.CheckTableAndField';
    FCheckTableAndFieldCommand.Prepare(TSvrSQLMethods_CheckTableAndField);
  end;
  FCheckTableAndFieldCommand.Parameters[0].Value.SetWideString(s);
  FCheckTableAndFieldCommand.Execute(ARequestFilter);
  Result := FCheckTableAndFieldCommand.Parameters[1].Value.GetBoolean;
end;

procedure TSvrSQLMethodsClient.BeginTransactions;
begin
  if FBeginTransactionsCommand = nil then
  begin
    FBeginTransactionsCommand := FConnection.CreateCommand;
    FBeginTransactionsCommand.RequestType := 'GET';
    FBeginTransactionsCommand.Text := 'TSvrSQLMethods.BeginTransactions';
  end;
  FBeginTransactionsCommand.Execute;
end;

procedure TSvrSQLMethodsClient.CommitTransactions;
begin
  if FCommitTransactionsCommand = nil then
  begin
    FCommitTransactionsCommand := FConnection.CreateCommand;
    FCommitTransactionsCommand.RequestType := 'GET';
    FCommitTransactionsCommand.Text := 'TSvrSQLMethods.CommitTransactions';
  end;
  FCommitTransactionsCommand.Execute;
end;

procedure TSvrSQLMethodsClient.RollbackTransactions;
begin
  if FRollbackTransactionsCommand = nil then
  begin
    FRollbackTransactionsCommand := FConnection.CreateCommand;
    FRollbackTransactionsCommand.RequestType := 'GET';
    FRollbackTransactionsCommand.Text := 'TSvrSQLMethods.RollbackTransactions';
  end;
  FRollbackTransactionsCommand.Execute;
end;

function TSvrSQLMethodsClient.EchoString(Value: string; const ARequestFilter: string): string;
begin
  if FEchoStringCommand = nil then
  begin
    FEchoStringCommand := FConnection.CreateCommand;
    FEchoStringCommand.RequestType := 'GET';
    FEchoStringCommand.Text := 'TSvrSQLMethods.EchoString';
    FEchoStringCommand.Prepare(TSvrSQLMethods_EchoString);
  end;
  FEchoStringCommand.Parameters[0].Value.SetWideString(Value);
  FEchoStringCommand.Execute(ARequestFilter);
  Result := FEchoStringCommand.Parameters[1].Value.GetWideString;
end;

function TSvrSQLMethodsClient.ReverseString(Value: string; const ARequestFilter: string): string;
begin
  if FReverseStringCommand = nil then
  begin
    FReverseStringCommand := FConnection.CreateCommand;
    FReverseStringCommand.RequestType := 'GET';
    FReverseStringCommand.Text := 'TSvrSQLMethods.ReverseString';
    FReverseStringCommand.Prepare(TSvrSQLMethods_ReverseString);
  end;
  FReverseStringCommand.Parameters[0].Value.SetWideString(Value);
  FReverseStringCommand.Execute(ARequestFilter);
  Result := FReverseStringCommand.Parameters[1].Value.GetWideString;
end;

procedure TSvrSQLMethodsClient.CreateDataProvider;
begin
  if FCreateDataProviderCommand = nil then
  begin
    FCreateDataProviderCommand := FConnection.CreateCommand;
    FCreateDataProviderCommand.RequestType := 'GET';
    FCreateDataProviderCommand.Text := 'TSvrSQLMethods.CreateDataProvider';
  end;
  FCreateDataProviderCommand.Execute;
end;

procedure TSvrSQLMethodsClient.ReleaseDataProvider;
begin
  if FReleaseDataProviderCommand = nil then
  begin
    FReleaseDataProviderCommand := FConnection.CreateCommand;
    FReleaseDataProviderCommand.RequestType := 'GET';
    FReleaseDataProviderCommand.Text := 'TSvrSQLMethods.ReleaseDataProvider';
  end;
  FReleaseDataProviderCommand.Execute;
end;

constructor TSvrSQLMethodsClient.Create(ARestConnection: TDSRestConnection);
begin
  inherited Create(ARestConnection);
end;

constructor TSvrSQLMethodsClient.Create(ARestConnection: TDSRestConnection; AInstanceOwner: Boolean);
begin
  inherited Create(ARestConnection, AInstanceOwner);
end;

destructor TSvrSQLMethodsClient.Destroy;
begin
  FLoginCommand.DisposeOf;
  FConnectionStringCommand.DisposeOf;
  FExecSQLCommand.DisposeOf;
  FExecResSQLCommand.DisposeOf;
  FOpenSQLCommand.DisposeOf;
  FOpenSQLCommand_Cache.DisposeOf;
  FOpenResSQLCommand.DisposeOf;
  FOpenResSQLCommand_Cache.DisposeOf;
  FApplyUpdatesByDSCommand.DisposeOf;
  FCheckTableAndFieldCommand.DisposeOf;
  FBeginTransactionsCommand.DisposeOf;
  FCommitTransactionsCommand.DisposeOf;
  FRollbackTransactionsCommand.DisposeOf;
  FEchoStringCommand.DisposeOf;
  FReverseStringCommand.DisposeOf;
  FCreateDataProviderCommand.DisposeOf;
  FReleaseDataProviderCommand.DisposeOf;
  inherited;
end;

end.
